
import 'package:flutter/material.dart';

/// Statics
const PENDO_OPTIONS = 'PendoOptions';
const APPLICATION_KEY = 'ApplicationKey';
const PLATFORM_VERSION = 'PlatformVersion';
const VISITOR_ID = 'VisitorID';
const ACCOUNT_ID = 'AccountID';
const VISITOR_DATA = 'VisitorData';
const ACCOUNT_DATA = 'AccountData';
const IS_DEBUG_ENABLED = 'IsDebugEnabled';
const DISMISS_GUIDES = 'DismissGuides';
const TRACK_EVENT_NAME = 'EventName';
const TRACK_EVENT_PROPERTY = 'EventProperties';

/// APIs
const SETUP = 'setup';
const START_SESSION = 'startSession';
const SET_VISITOR_DATA = 'setVisitorData';
const SET_ACCOUNT_DATA = 'setAccountData';
const GET_ACCOUNT_DATA = 'getVisitorId';
const GET_ACCOUNT_ID = 'getAccountId';
const GET_DEVICE_ID = 'getDeviceId';
const SET_DEBUG_MODE = 'setDebugMode';
const PAUSE_GUIDES = 'pauseGuides';
const RESUME_GUIDES = 'resumeGuides';
const DISMISS_VISIBLE_GUIDES = 'dismissVisibleGuides';
const TRACK = 'track';
const END_SESSION = 'endSession';
const SCREEN_CHANGED = 'screenChanged';

/// ScreenElementInfoKeys
const SELECTED_TITLE_TEXT = 'selectedTitleText';
const NUMBER_OF_INDEXES = 'numberOfIndexes';
const KIND = 'kind';
const DEPTH = 'depth';
const SELECTED_INDEX = 'selectedIndex';

/// ScreenChildElementKeys
const NAME = 'name';
const INFO = 'info';

/// RetroactiveScreenDataKeys
const RETROACTIVE_SCREEN_DATA = 'retroactiveScreenData';
const RETROACTIVE_SCREEN_ID = 'retroactiveScreenId';
const CURRENT_SCREEN_NAME = 'currentScreenName';
const PREVIOUS_SCREEN_NAME = 'previousScreenName';
const CHILD_VIEWS = 'childViews';
const TEXTS = 'texts';
const TREE = 'tree';

/// ElementInfoKeys
const ROOT_VIEW = 'rootView';
const ELEMENT_HASH_CODE = 'elementHashCode';
const ELEMENT_DEPTH = 'elementDepth';
const ELEMENT_TYPE_NAME = 'elementTypeName';
const TEXT = 'text';
const ICON_CODE = 'iconCode';
const IMAGE_NAME = 'imageName';
const IS_CONTAINER = 'isContainer';
const IS_CLICKABLE = 'isClickable';
const FRAME = 'frame';
const WIDGET_TYPE = 'widgetType';
const TYPE = 'type';
const KEY = 'key';
const LOCALE = 'locale';
const FONT_FAMILY = 'family';
const COLOR = 'color';
const ENABLED = 'enabled';
const TOGGLEABLE = 'toggleable';
const ON_TAP = 'onTap';
const ON_TAP_UP = 'onTapUp';
const ON_DOUBLE_TAP = 'onDoubleTap';
const ON_PRESSED = 'onPressed';
const ON_LONG_PRESS = 'onLongPress';
const ON_HOVER = 'onHover';
const ON_SELECTED = 'onSelected';
const ON_OPENED = 'onOpened';
const ON_SELECTION_CHANGED = 'onSelectionChanged';
const ON_CHANGED = 'onChanged';
const ON_DELETED = 'onDeleted';
const ON_SUBMITTED = 'onSubmitted';
const ON_TAP_OUTSIDE = 'onTapOutside';
const ON_EDITTING_COMPLETE = 'onEdittingComplete';
const VALUE = 'value';
const TOOLTIP_MESSAGE = 'tooltipMessage';
const LAYOUT_ID = 'layoutId';
const SEMANTIC_LABEL = 'semanticLabel';
const AVATAR = 'avatar';
const DELETE_ICON = 'deleteIcon';
const ICON = 'icon';
const SELECTED_ICON = 'selectedIcon';
const CHILD = 'child';
const TITLE = 'title';
const SUBTITLE = 'subtitle';
const LEADING = 'leading';
const TRAILING = 'trailing';
const CHILD_COUNT = 'childCount';
const INDEX = 'index';
const MIN = 'min';
const MAX = 'max';
const TRISTATE = 'tristate';
const MINI = 'mini';
const IS_SELECTED = 'isSelected';
const PREDICATE = 'predicate';
const PENDO_PREDICATE = 'pendoPredicate';
const WIDGET_INFO = 'widgetInfo';
const X = 'x';
const Y = 'y';
const HEIGHT = 'height';
const WIDTH = 'width';
const ACCESSIBILITY_LABEL = 'accessibilityLabel';
const ACCESSIBILITY_HINT = 'accessibilityHint';
const BACK_ICON_CODE = 57491;
const LABEL = 'label';
const HINT = 'hint';
const DIRECTION = 'direction';
const CHILDRENCOUNT = 'childrenCount';
const ITEMEXTENT = 'itemExtent';
const INTERVAL = 'interval';
const DEVISION = 'devision';
const SUBDEVISION = 'subDevision';
const ROWS = 'rows';
const COLUMNS = 'columns';
const LABEL_BASE64 = 'labelBase64';
const HINT_BASE64 = 'hintBase64';
const ZINDEX = 'zIndex';
const CLICKABLE = 'clickable';
const DESC_TEXT_BASE64 = 'descriptiveTextBase64';
const TEXT_BASE64 = 'textBase64';
const POSITION = 'position';
const LEFT = 'left';
const TOP = 'top';
const RETRO_ELEMENT_INFO = 'retroElementInfo';
const ACTIONS = 'actions';
const ACCESSIBILITY = 'accessibility';
const RETRO_ELEMENT_TEXTS = 'retroElementTexts';
const RETRO_ELEMENT_HASHES_COLLECTION = 'retroElementHashesCollection';

/// DataTree
const ROOT = 'root';
const LAYOUT_ID_WIDGET = 'LayoutId';
const INDEXED_SEMANTICS_WIDGET = 'IndexedSemantics';
const PROGRESS_INDICATOR_WIDGET = 'ProgressIndicator';
const THEATER_WIDGET = '_Theater';
const OVERLAY_ENTRY_WIDGET = '_OverlayEntryWidget';

/// TreeElement
const CHILDREN = 'children';
const ELEMENT_INFO = 'elementInfo';

/// ScanUtils
/// element types
const BOTTOM_NAVIGATION_BAR = 'BottomNavigationBar';
const TAB_BAR = 'TabBar';
const DRAWER = 'Drawer';
const END_DRAWER = 'EndDrawer';
const TABBARVIEW = 'TabBarView';
const ROW = 'Row';
const LISTVIEW = 'ListView';
const SILVERFIXEDEXTENTLIST = 'SliverFixedExtentList';
const GRIDPAPER = 'GridPaper';
const FLOW = 'Flow';
const DATATABLE = 'DataTable';

/// retroactiveScreenIds
const DRAWER_SCREEN_ID = '__DRAWER__';
const MODAL_SCREEN_ID = '__MODAL__';

/// modal candidates
const DIALOGUE_ROUTE_CANDIDATE = 'DialogRoute<';
const POPUP_MENU_ROUTE_CANDIDATE = '_PopupMenuRoute<';
const CUPERTINO_DIALOG_CANDIDATE = 'CupertinoDialogRoute<';
const CUPERTINO_MODAL_POPUP_ROUTE_CANDIDATE = 'CupertinoModalPopupRoute<';

/// configurations
// Used for configure the scann algorithm
const SCAN_ONLY_CURRENT_FOCUSED_SCREEN = 'ScanOnlyCurrentFocusedScreen';
const SQUASH_NESTED_CLICKABLE_ELEMENTS = 'SquashNestedClickableElements';

/// TODO: Temporary solution till we slove the problem with Flutter RootWidget
class PendoRootWidget extends Widget {
  @override
  Element createElement() {
    // TODO: implement createElement
    throw UnimplementedError();
  }
} 

