import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

// !! we ignore using relative imports only for known issue with logger.dart static filds
// ignore: prefer_relative_imports
import 'package:pendo_sdk/src/logger.dart';


extension ImageUtils on Image {

  String? imageInfo() => _imageInfoFromImageProvider(this.image);

  String? _imageInfoFromImageProvider(ImageProvider imageProvider) {

    if (imageProvider is AssetImage) {
      return imageProvider.assetName;
    }

    if (imageProvider is ExactAssetImage) {
      return imageProvider.assetName;
    }

    if (imageProvider is NetworkImage) {
      return  imageProvider.url;
    }

    if (imageProvider is FileImage) {
      return imageProvider.file.path;
    }

    if (imageProvider is ResizeImage || imageProvider is ScrollAwareImageProvider) {
      return _imageInfoFromImageProvider(this.image);
    }

    Logger.w('Image extraction failed for image provider: ${image.runtimeType}');
    return null;
  }

}