import 'dart:ui';

extension RectContainment on Rect {
  // TODO: we will need to verify that it works like we expect. 
  // ie: this will fail in case frames are outside the screen for ex: (-1, -5, 50, 50)
  static const double kThreshold = 10.0;

  bool aproximateContainsRectangle(Rect another, {double threshold = kThreshold}) {
    double dx = another.left - left;
    double dy = another.top - top;
    double dw = (left + width) - (another.left + another.width);
    double dh = (top + height) - (another.top + another.height);

    bool result = 
    dx >= 0 && dx <= threshold && 
    dy >= 0 && dy <= threshold &&
    dw >= 0 && dw <= threshold &&
    dh >= 0 && dh <= threshold;

    return result;
  }
}